<?php
/**
 * Created by JetBrains PhpStorm.
 * User: erikasouza
 * Date: 20/11/12
 * Time: 17:31
 * To change this template use File | Settings | File Templates.
 */
namespace Estoque\Logic\Exception;

class ExceptionFechamentoDia extends \Geral\Logic\Exception
{


    private $messageName;
    private $params;
    private $messageNameAcumulado;
    private $paramsAcumulado;


    public function __construct($messagemName, array $param = null){
        parent::__construct($messagemName);
        $this->messageName = $messagemName;
        $this->params = $param;
    }

    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }

    /**
     * Retorna o parametro da mensagem para esta excecao.
     *
     * @return string
     */
    public function getParam()
    {
        return $this->getParams();
    }


    public function acumulaMensagem($NmMensagem, $params){
        $this->messageNameAcumulado = $NmMensagem;
        $this->paramsAcumulado = $params;
    }


    public static function erroDivergencia(){
        throw new self('fechDia_divergenciaEstoque');
    }


    public static function erroEstoqueCego(){
        throw new self('fechDia_estoqueCego');
    }


    public static function erroSemEfetivos(){
        throw new self('fecDia_semEfetivos');
    }


    public static function erroRetiradaSemNF(){
        throw new self('fechDia_retiradaSemNF');
    }


    public static function erroEntradaSemNF(){
        throw new self('fechDia_entradaSemNF');
    }


    public static function erroProdutoIrregular(){
        throw new self('fechDia_produtoIrregular');
    }


    public static function erroFechMesSemDt(){
        throw new self('fechDia_fechMesSemData');
    }


    public static function erroSemAlmoxarifado(){
        throw new self('fechDia_semAlmoxarifado');
    }


    public static function erroSemLocalizacao(){
        throw new self('fechDia_semLocalizacao');
    }


    public static function erroInventPendFilial(){
        throw new self('fechDia_inventPendFilial');
    }

    //@todo não existe no metadados
    public static function erroCalculoSimples(){
        throw new self('fechDia_ErroCalculoSimples');
    }

	//@todo não existe no metadados
    public static function erroAtualizaDtReceita(){
        throw new self('fechDia_erroAtualDtReceita');
    }


    public static function erroNFSemEntrada(){
        throw new self('fechDia_NFsemEntrada');
    }


    public static function erroNFSemSaida(){
        throw new self('fechDia_NFsemSaida');
    }


    public static function sucessoFechamentoOK(){
        throw new self('fechDia_FechamentoOk');
    }


    public static function erroInventariado(){
        throw new self('fechDia_ErroInventariado');
    }


    public static function erroTransacao(){
        throw new self('fechDia_ErroTransacao');
    }

    //@todo não existe no metadados
    public static function erroAtualizaEstoqueCego(){
        throw new self('fechDia_erroAtualEstoqueCego');
    }


    public static function erroInventPendAlmoxLocal($param){
        throw new self('fechDia_inventPendAlmoLocal', $param);
    }

    public static function erroInventPendentAlmox($param){
        throw new self('fechDia_inventPendAlmo', $param);
    }

    public static function erroProxDataVazia(){
    	throw new self('fechDia_proxDataVazia');
    }
    
    public static function erroProxDataMenor(){
    	throw new self('fechDia_proxDataMenor');
    }
    
    public static function erroDataJaFechada(){
    	throw new self('fechDia_DataJaFechada');
    }
	
    public static function erroSemLancamento(){
    	throw new self('fechDia_semLancamento');
    }

    public static function erroSaidaNaoEmitida(){
    	throw new self('fechDia_saidaNaoEmitida');
    }
    
}
