function ParametrizacaoFiscalCentralizada() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const self = this;

	this.adicionarRegraFiscal = (nome, agrupamentoImposto, validadeInicial, grupoFiscal, observacao) => {
		geral.fillFields(
			'NMREGRAFISC', nome,
			'DSMENSREGRAFISC', observacao,
		);
		geral.searchAndClickGridField('NMGRUPIMPOSTO', agrupamentoImposto, 'NMGRUPIMPOSTO');
		geral.selectNative('IDUTGRUPOFISCAL', grupoFiscal);
		z.field.calendar.openCalendarByIconClick('DTVALREGRAFISC');
		z.field.calendar.clickDate(validadeInicial, 'pt_br');
	};

	this.editarRegraFiscal = (nome, agrupamentoImposto, validadeInicial, grupoFiscal, observacao) => {
		geral.fllField('NMREGRAFISC', nome);
		geral.clickLimparAutoComplete('NMGRUPIMPOSTO');
		geral.searchAndClickGridField('NMGRUPIMPOSTO', agrupamentoImposto, 'NMGRUPIMPOSTO');
		geral.clickLimparAutoComplete('DTVALREGRAFISC');
		z.field.calendar.openCalendarByIconClick('DTVALREGRAFISC');
		z.field.calendar.clickDate(validadeInicial, 'pt_br');
		geral.selectNative('IDUTGRUPOFISCAL', grupoFiscal);
		geral.fllField('DSMENSREGRAFISC', observacao);
	};

	this.adicionarImposto = (imposto, obrigatorio) => {
		geral.searchAndClickGridField('NMIMPOSTO', imposto, 'CDIMPOSTO');
		geral.selectNative('IDIMPOBRIGREGRA', obrigatorio);
	};

	this.editarImposto = (obrigatorio) => {
		geral.selectNative('IDIMPOBRIGREGRA', obrigatorio);
	};

	this.adicionarComumRegra = (codigoFiscal, cst, aliquota, operacaoInterestadual, operacaoInternacional,
		BcdoICMS, BcICMS, motivoDesoneracao, tipodeCredito, naturezaBaseCalculo, naturezaBaseReceita, codigoDetalhamento) => {
		geral.selectNative('CDFISCAL', codigoFiscal);
		geral.searchAndClickGridField('CDSITUTRIB', cst, 'CDSITUTRIB');
		geral.selectNatives('IDCSTINTEREST', operacaoInterestadual,
			'IDCSTINTERNA', operacaoInternacional,
			'IDMODBCNFE', BcdoICMS,
			'IDMODBCSTNFE', BcICMS,
			'IDMOTIDESSTNFE', motivoDesoneracao);
		geral.fillFields('VRALIQUOTA', aliquota,
			'CDTPCRPICOSTNFE', tipodeCredito,
			'CDNATUBCPCSTNFE', naturezaBaseCalculo,
			'CDNATUREC', naturezaBaseReceita,
			'CDDETALHEFISC', codigoDetalhamento);
	};

	this.adicionarRegraNCM = (classificacaoFiscal, codigoFiscal, cst, aliquota, operacaoInterestadual,
		operacaoInternacional, BcdoICMS, BcICMS, motivoDesoneracao, tipodeCredito, naturezaBaseCalculo,
		naturezaBaseReceita, codigoDetalhamento, rangeInicial, rangeFinal, unidadeMedida) => {
		self.adicionarRegraPadrao(codigoFiscal, cst, aliquota, operacaoInterestadual, operacaoInternacional,
			BcdoICMS, BcICMS, motivoDesoneracao, tipodeCredito, naturezaBaseCalculo, naturezaBaseReceita, codigoDetalhamento);
		geral.searchAndClickGridFields('DSCLASFISC', classificacaoFiscal, 'DSCLASFISC', '9000',
			'SGUNIDEMB', unidadeMedida, 'DSUNIDADE', '9000');
		geral.fillFields('VRRANGINI', rangeInicial,
			'VRRANGFIM', rangeFinal);
	};

	this.adicionarRegraProduto = (produto, codigoFiscal, cst, aliquota, operacaoInterestadual,
		operacaoInternacional, BcdoICMS, BcICMS, motivoDesoneracao, tipodeCredito, naturezaBaseCalculo,
		naturezaBaseReceita, codigoDetalhamento) => {
		self.adicionarRegraPadrao(codigoFiscal, cst, aliquota, operacaoInterestadual, operacaoInternacional,
			BcdoICMS, BcICMS, motivoDesoneracao, tipodeCredito, naturezaBaseCalculo, naturezaBaseReceita, codigoDetalhamento,
		);
		geral.searchAndClickGridField('NMPRODUTO', produto, 'NMPRODUTO');
		geral.fillFields('CDNATUBCPCSTNFE', naturezaBaseCalculo);
	};
}
module.exports = new ParametrizacaoFiscalCentralizada();
